#include <iostream>
using namespace std;
int main(int argc, char** argv) {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	int n,m;
	cin >>n>>m;
	
	unsigned long long int matrix[n+1][m+1];
	for(int i=1;i<n+1;i++)
	{
		for(int j=1;j<m+1;j++)
		{
			cin >>matrix[i][j];
		}
	}
	unsigned long long int dp[n+1][m+1];
	dp[1][1]=matrix[1][1];
	
	
	
	int t;
	cin >>t;
	for(int z=0;z<t;z++)
	{
		int starty,startx;
		cin >>starty>>startx;
		unsigned long long int pom=matrix[starty][startx];
		matrix[starty][startx]=1000000000000000000;
		for(int i=2;i<n+1;i++)
		{
			
			dp[i][1]=dp[i-1][1]+matrix[i][1];
		}
		for(int j=2;j<m+1;j++)
		{
			dp[1][j]=dp[1][j-1]+matrix[1][j];
		}
		for(int i=2;i<n+1;i++)
		{
			for(int j=2;j<m+1;j++)
			{
				if(starty==i-1 && startx==j)
				{
					dp[i][j]=matrix[i][j]+dp[i][j-1];
				}
				else if(starty==i && startx==j-1)
				{
					dp[i][j]=matrix[i][j]+dp[i+1][j];
				}
				else
				{
					dp[i][j]=matrix[i][j]+min(dp[i][j-1],dp[i-1][j]);
				}
			}
		}
		/*for(int i=1;i<n+1;i++)
		{
			for(int j=1;j<m+1;j++)
			{
				cout <<dp[i][j]<<" ";
			}
			cout <<"\n";
		}*/
		cout <<dp[n][m]<<"\n";
		matrix[starty][startx]=pom;
	}
	
	return 0;
}